effectSystem = filteredSystem("effects", { canReceive })

Effects = {}

---@param entity { canBeBounced: CanBeBounced }
function Effects.makeBouncier(entity)
    entity.canBeBounced.mult = entity.canBeBounced.mult * 1.5
end

---@param entity { mass: number }
function Effects.makeFloatier(entity)
    entity.mass = entity.mass * 0.75
end

--- Cause the given ingredient to spawn more frequently
function Effects.moreOfIngredient(ingredient, spawner) end

--- Each of the given ingredient will have a *mult score from now on.
function Effects.multiplyIngredientValue(ingredient, mult, spawner) end

--- Each ingredient *multiplies* score in some way, in addition to adding.
function Effects.multiplicativeIngredientValue(ingredient, addedMult, spawner) end
