local gfx <const> = playdate.graphics

drawRectanglesSystem = filteredSystem("drawRectangles", { position = T.XyPair, drawAsRectangle = { size = T.XyPair } }, function(e, dt)
    gfx.fillRect(e.position.x, e.position.y, e.drawAsRectangle.size.x, e.drawAsRectangle.size.y)
end)

drawSpriteSystem = filteredSystem("drawSprites", { position = T.XyPair, drawAsSprite = T.PdImage }, function(e, dt, system)
    e.drawAsSprite:draw(e.position.x, e.position.y)
end)

local textHeight = AshevilleSans14Bold:getHeight()
local xMargin = 4

drawTextSystem = filteredSystem("drawText",
    { position = T.XyPair, drawAsText = { text = T.str, style = Maybe(T.str), font = Maybe(T.PdFont) } },
    function(e)
        local textWidth = AshevilleSans14Bold:getTextWidth(e.drawAsText.text)
        if e.drawAsText.style == TextStyle.Inverted then
            gfx.fillRect(
                e.position.x - xMargin - textWidth / 2,
                e.position.y - 2,
                textWidth + (xMargin * 2),
                textHeight + 2
            )
            gfx.setImageDrawMode(gfx.kDrawModeInverted)
        end
        if e.drawAsText.style == TextStyle.Bordered then
            gfx.setColor(gfx.kColorWhite)
            gfx.fillRect(
                e.position.x - xMargin - textWidth / 2,
                e.position.y - 2,
                textWidth + (xMargin * 2),
                textHeight + 2
            )
            gfx.setColor(gfx.kColorBlack)
            gfx.setImageDrawMode(gfx.kDrawModeCopy)
            gfx.drawRect(
                e.position.x - xMargin - textWidth / 2,
                e.position.y - 2,
                textWidth + (xMargin * 2),
                textHeight + 2
            )
        end
        AshevilleSans14Bold:drawTextAligned(e.drawAsText.text, e.position.x, e.position.y, kTextAlignment.center)
        if e.drawAsText.style == TextStyle.Inverted then
            gfx.setImageDrawMode(gfx.kDrawModeCopy)
        end
    end
)
