---@alias MenuItem { onSelect: fun(), highlighted: boolean, navigateDown: MenuItem | nil, navigateUp: MenuItem | nil }

---@type MenuItem[]
local MenuItems = {}

menuController = filteredSystem("menuController", { menuItems = MenuItems, inputState = T.InputState }, function(e, _, system)
    for _, menuItem in pairs(e.menuItems) do
        if menuItem.highlighted then
            if e.inputState.aJustPressed then
                menuItem.onSelect(system.world)
                for _, item in pairs(e.menuItems) do
                    system.world:removeEntity(item)
                end
                system.world:removeEntity(e)
            end
            if e.inputState.downJustPressed and menuItem.navigateDown then
                menuItem.highlighted = false
                menuItem.navigateDown.highlighted = true
                return
            end
            if e.inputState.upJustPressed and menuItem.navigateUp then
                menuItem.highlighted = false
                menuItem.navigateUp.highlighted = true
                return
            end
        end
    end
    for _, menuItem in pairs(e.menuItems) do
        if menuItem.highlighted then
            menuItem.drawAsText.style = TextStyle.Inverted
        else
            menuItem.drawAsText.style = TextStyle.Bordered
        end
    end
end)
